diff --git a/modules_k/xcap_server/xcap_server.c b/modules_k/xcap_server/xcap_server.c
index 7b44585..ff9d8c8 100644
--- a/modules_k/xcap_server/xcap_server.c
+++ b/modules_k/xcap_server/xcap_server.c
@@ -933,6 +933,28 @@ static int w_xcaps_get(sip_msg_t* msg, char* puri, char* ppath)
 		LM_ERR("could not fetch xcap document\n");
 		goto error;
 	}
+	
+	if (xuri.node.s != NULL) 
+	{		
+		if(xcaps_xpath_hack(&body, 0)<0)
+		{
+			LM_ERR("could not hack xcap document\n");
+			goto error;
+		}
+		
+		if(xcaps_xpath_get(&body, &xuri.node, &body)<0)
+		{
+			LM_ERR("could not filter xml document\n");
+			goto error;
+		}
+		
+		if(xcaps_xpath_hack(&body, 1)<0)
+		{
+			LM_ERR("could not hack xcap document\n");
+			goto error;
+		}
+	} 
+	
 	if(ret==0)
 	{
 		/* doc found */
